/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#include "mt19937ar.h"

//  The MD5 checksum of the correct output is
//    cb33e6acc162cbe20f7fcac26adddd02
//  and it is 22465 bytes long.
//
//  but we cannot use md5, as it's in libbri, and
//  so is this...

int main(void) {
    int i;
    u32bit init[4] = {0x123, 0x234, 0x345, 0x456};
    u32bit length  = 4;
    mt_s *ctx = mtInitArray(init, length);

    printf("1000 outputs of genrand_int32()\n");

    for (i=0; i<1000; i++) {
      printf("%10lu ", mtRandom32(ctx));
      if (i%5==4) printf("\n");
    }

    printf("\n1000 outputs of genrand_real2()\n");

    for (i=0; i<1000; i++) {
      printf("%10.8f ", mtRandomRealOpen(ctx));
      if (i%5==4) printf("\n");
    }



    for (i=0; i<999; i++) {
      printf(u64bitHEX" ", mtRandom64(ctx));
      if (i%3==2) printf("\n");
    }

    return 0;
}
