#!/usr/bin/perl

# This file is part of ESTmapper.
# Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
# Authors: Brian Walenz and Liliana Florea
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received (LICENSE.txt) a copy of the GNU General Public 
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



$| = 1;

use strict;
use lib "/work/assembly/walenzbp/projects/scripts";
use libBri;

#  Regenerates the sim4db script from a set of polishes.
#  Does NOT sort by genomic, or remove duplicates.

my $extension = 0;
if (scalar(@ARGV) > 0) {
    $extension = int(shift(@ARGV));
}

print STDERR "Extending the regions by $extension in both directions.\n";

while (!eof(STDIN)) {
    my %p = &libBri::readPolish(*STDIN);

    #  Modify the limits, if desired.
    #
    my $l = $p{'dbLo'} - $extension;
    my $h = $p{'dbHi'} + $extension;

    $l = 0 if ($l < 0);

    if ($p{'matchOrientation'} eq "forward") {
        print "-f -e $p{'estID'} -D $p{'dbID'} $l $h\n";
    } else {
        print "-r -e $p{'estID'} -D $p{'dbID'} $l $h\n";
    }
}

