// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#ifndef AHIT_H
#define AHIT_H

#include "bri.h"
#include <stdio.h>

//  The field called _flgas used to be _direction and held just the
//  orientation of the match.  So that we can use sortHits for both
//  seatac and searchGENOME, this was extended to a _flags field.
//
//  FLAG_DIRECTION -- if set, the match is forward, otherwise reverse.

#define FLAG_DIRECTION    0x00000001

struct aHit {
  u32bit  _direction;
  u32bit  _qsIdx;
  u32bit  _dsIdx;
  u32bit  _dsLo;
  u32bit  _dsHi;
  u32bit  _covered;
  u32bit  _matched;
  u32bit  _numMers;
};


void   ahit_writeBinary(aHit *a, FILE *F);
void   ahit_readBinary(aHit *a, FILE *F);

void   ahit_printASCII(aHit *a, FILE *F);
void   ahit_parseString(aHit *a, char *b);

#endif  //  AHIT_H

