// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "posix.H"
#include <stdio.h>
#include <stdlib.h>
#include "aHit.H"

//  $Id: hitConverter.C,v 1.3 2003/01/06 19:47:26 walenz Exp $

#ifdef TRUE64BIT
char const *hitStr = "%u hits.\r";
#else
char const *hitStr = "%lu hits.\r";
#endif

void
bin2asc(FILE *I, FILE *O) {
  u32bit  i = 0;
  aHit    a;

  fprintf(stderr, "Converting BINARY to ASCII.\n");

  while (!feof(I)) {
    ahit_readBinary(&a, I);

    if (!feof(I)) {
      ahit_printASCII(&a, O);

      if ((++i & 0xffff) == 0) {
        fprintf(stderr, hitStr, i);
        fflush(stderr);
      }
    }
  }

  fprintf(stderr, hitStr, i);
  fprintf(stderr, "\n");
}


void
asc2bin(FILE *I, FILE *O) {
  u32bit  i = 0;
  aHit    a;
  char    b[1025];

  fprintf(stderr, "Converting ASCII to BINARY.\n");

  while (!feof(I)) {
    fgets(b, 1024, I);

    if (!feof(I)) {
      ahit_parseString(&a, b);
      ahit_writeBinary(&a, O);

      if ((++i & 0xffff) == 0) {
        fprintf(stderr, hitStr, i);
        fflush(stderr);
      }
    }
  }

  fprintf(stderr, hitStr, i);
  fprintf(stderr, "\n");
}


int
main(int argc, char **argv) {

  if (argc != 1) {
    fprintf(stderr, "%s: I only read stdin and write stdout.\n", argv[0]);
    exit(1);
  }

  //  If the first character in the stream is ascii, do ASCII -> BINARY.
  //  Else, do BINARY -> ASCII.
  //
  char x = (char)fgetc(stdin);
  ungetc(x, stdin);

  if (x == '-')
    asc2bin(stdin, stdout);
  else
    bin2asc(stdin, stdout);

  return(0);
}
