// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#ifndef STATOBJ_H
#define STATOBJ_H

#include <stdio.h>
#include <stdlib.h>
#include "sharedObj.H"


class statObj {
public:
  statObj(sharedObj *so, char *soOpts);
  ~statObj();

  void   add(filterObj *FO) {
    if (soadd)
      (*soadd)(handle, FO->handle);
  };

  void   show(FILE *file) {
    if (soshow)
      (*soshow)(handle, file);
  };

private:
  char        *soOpts;
  sharedObj   *so;

  void        *handle;

  void *     (*soconstruct)(char *);
  void       (*sodestruct)(void *);
  void       (*soadd)(void *, void *);
  void       (*soshow)(void *, FILE *);
};


inline
statObj::statObj(sharedObj *so_, char *op_) {
  soOpts       = 0L;
  so           = so_;

  handle       = 0L;

  soconstruct  = 0L;
  soadd        = 0L;
  soshow       = 0L;
  sodestruct   = 0L;

  if (op_) {
    soOpts = new char (strlen(op_) + 1);
    strcpy(soOpts, op_);
  }

  if (so) {
    soconstruct = (void* (*)(char*))so->get("constructStats");
    sodestruct  = (void  (*)(void*))so->get("destructStats");
    soadd       = (void  (*)(void*, void*))so->get("addStats");
    soshow      = (void  (*)(void*, FILE*))so->get("showStats");

    handle = (*soconstruct)(soOpts);
  }
}


inline
statObj::~statObj() {
  if (sodestruct)
    (*sodestruct)(handle);
  delete [] soOpts;
}


#endif  //  STATOBJ_H
