// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



//  Don't define this (unless your name starts with L or B).
//
//  Changes to here, sim4db.H and exon_cores.H
//
//#define INTERSPECIES

#define  DIST_CUTOFF       3

#define  MIN_INTRON        30
#define  SHORT_INTRON      50
#define  LONG_INTRON       20000
#define  SHORT_EXON        40
#define  MAX_GRINIT        500
#define  MAX_SLIDE         15
#define  MAX_INTERNAL_GAP  50

#define  DEFAULT_DRANGE    10
#define  DEFAULT_WEIGHT    100
#define  DEFAULT_RELINK_WEIGHT    500

#define  DEFAULT_K         16
#define  DEFAULT_C         12

#define  min(x,y)        ((x>y) ? (y):(x))
#define  max(x,y)        ((x<y) ? (y):(x))

#define  START_SIG       ((G_score >= abs(C_score)) ? "GT" : "CT") 
#define  END_SIG         ((G_score >= abs(C_score)) ? "AG" : "AC")

#define  DELETE          1
#define  INSERT          2
#define  SUBSTITUTE      3
#define  INTRON          4
#define  O_INTRON        5

#define  SPLICE_ORIGINAL         0
#define  SPLICE_GENESPLICER      1
#define  SPLICE_GLIMMER          2
#define  DEFAULT_SPLICE_MODEL    SPLICE_ORIGINAL

#define  DEFAULT_SPACED_SEED        "1xx1011011011xx11"
#define  DEFAULT_SPACED_SEED_INT    "10011010100011"
#define  DEFAULT_SPACED_SEED_EXT    "1101100011010111"
#define  SEED_SPAN               40   /* 22 */
