/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#include "sim4polish.h"
#include "memory.h"

#include <errno.h>
#include <string.h>

sim4polish *
s4p_copyPolish(sim4polish *orig) {
  int         i;
  sim4polish *copy = 0L;

  if (orig == 0L)
    return(copy);;

  copy = (sim4polish *)memdup(orig, sizeof(sim4polish));

  if (orig->estDefLine)
    copy->estDefLine = (char *)memdup(orig->estDefLine, sizeof(char) * (strlen(orig->estDefLine) + 1));

  if (orig->genDefLine)
    copy->genDefLine = (char *)memdup(orig->genDefLine, sizeof(char) * (strlen(orig->genDefLine) + 1));

  copy->exons = (sim4polishExon *)memdup(orig->exons, sizeof(sim4polishExon) * copy->numExons);

  for (i=0; i<copy->numExons; i++) {
    if (orig->exons[i].estAlignment)
      copy->exons[i].estAlignment = (char *)memdup(orig->exons[i].estAlignment, sizeof(char) * (strlen(copy->exons[i].estAlignment) + 1));

    if (orig->exons[i].genAlignment)
      copy->exons[i].genAlignment = (char *)memdup(orig->exons[i].genAlignment, sizeof(char) * (strlen(copy->exons[i].genAlignment) + 1));
  }

  return(copy);
}
