/**************************************************************************
 * This file is part of ESTmapper.
 * Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
 * Authors: Brian Walenz and Liliana Florea
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received (LICENSE.txt) a copy of the GNU General Public 
 * License along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**************************************************************************/


#include "sim4polish.h"


//  Bunch of misc functions that should have a better home


void
s4p_reverseComplement(sim4polish *p) {
  int e, t;

  if (p->matchOrientation == SIM4_MATCH_COMPLEMENT) {
    p->matchOrientation = SIM4_MATCH_FORWARD;

    for (e=0; e < p->numExons; e++) {
      t = p->estLen - p->exons[e].estFrom + 1;
      p->exons[e].estFrom = p->estLen - p->exons[e].estTo   + 1;
      p->exons[e].estTo = t;
    }
  } else {
    p->matchOrientation = SIM4_MATCH_COMPLEMENT;
  }
}


int
s4p_makeForward(sim4polish *p) {
  if (p->matchOrientation == SIM4_MATCH_COMPLEMENT) {
    s4p_reverseComplement(p);
    return(1);
  } else {
    return(0);
  }
}


int
s4p_makeReverse(sim4polish *p) {
  if (p->matchOrientation == SIM4_MATCH_FORWARD) {
    s4p_reverseComplement(p);
    return(1);
  } else {
    return(0);
  }
}


void
s4p_normalize(sim4polish *p) {
  int i;
  for (i=0; i<p->numExons; i++) {
    p->exons[i].genFrom += p->genLo;
    p->exons[i].genTo   += p->genLo;
  }
}
