// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#ifndef SIM4_POLISH_BUILDER_H
#define SIM4_POLISH_BUILDER_H

#include "sim4polish.h"

class sim4polishBuilder {
public:
  sim4polishBuilder();
  ~sim4polishBuilder();

  void          create(u32bit estid, u32bit estlen,
                       u32bit genid, u32bit genlo, u32bit genhi);

  void          setPolyTails(u32bit pa,
                             u32bit pt);

  void          setESTdefline(char *defline);
  void          setGENdefline(char *defline);

  void          setNumberOfMatches(u32bit nummatches, u32bit nummatchesN);
  void          setPercentIdentity(u32bit id);
  void          setMatchOrientation(char o);
  void          setStrandOrientation(char o);

  void          addExon(u32bit estlo, u32bit esthi,
                        u32bit genlo, u32bit genhi,
                        u32bit nummatches, u32bit nummatchesN, u32bit percentid,
                        char intronorientation);

  void          addExonAlignment(char *estalign,
                                 char *genalign);

  sim4polish   *release(void);
private:
  sim4polish      *it;

  u32bit           exMax;  //  maximum number of exons available
  u32bit           exPos;  //  next exon
  u32bit           exAli;  //  next exon without alignment
  sim4polishExon **ex;
};

#endif  //  SIM4_POLISH_BUILDER_H
