#!/usr/bin/perl

# This file is part of ESTmapper.
# Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
# Authors: Brian Walenz and Liliana Florea
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received (LICENSE.txt) a copy of the GNU General Public 
# License along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA



use lib "/work/assembly/walenzbp/projects/scripts";
use libBri;

while (!eof(STDIN)) {
    my %p = &libBri::readPolish(*STDIN);

    if (defined($p{'raw'})) {
        my $status = "$p{'numMatches'}-$p{'numMatchesN'}-$p{'percentID'}-$p{'matchOrientation'}-$p{'strandPrediction'}";
        my $st = 0;
        my $ed = 0;
        my $ll = 0;

        foreach my $exon (@{$p{'exons'}}) {
            if ($exon->{'GENOMICend'} - $exon->{'GENOMICstart'} > $ll) {
                $st = $p{'dbLo'} + $exon->{'GENOMICstart'};
                $ed = $p{'dbLo'} + $exon->{'GENOMICend'} + 1;
                $ll = $exon->{'GENOMICend'} - $exon->{'GENOMICstart'};
            }
        }

        print "$p{'estID'}\[$p{'estLen'}-$p{'pA'}-$p{'pT'}\] $p{'dbID'}\[$st-$ed\] <$status>\n";
    }
}
