// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include <stdio.h>
#include <stdlib.h>

#include "fasta.H"
#include "fasta-cache.H"

//  Quick-n-dirty example of using the quick-n-dirty fasta cache
//
//  cxx -I../libbri -I../fasta -o cache cache.C ../fasta/libfasta.a ../libbri/libbri.a


int
main(int argc, char **argv) {

  if (argc != 3) {
    fprintf(stderr, "usage: %s idx-to-get fasta-file\n", argv[0]);
    exit(1);
  }

  //  Build a fasta-cache of whatever file is on the command line
  //    The 32 is a useless parameter here...
  //    'true' says to really load all the sequences at the start
  //
  FastACache  cache(argv[2], 32, true);

  //  Grab the second sequence from the cache
  //
  FastASequenceInCore  *seq = cache.getSequence(atoi(argv[1]));

  //  And do something with the sequence
  //
  fprintf(stdout, "%s\n%s\n", seq->header(), seq->sequence());

  //  Don't delete seq, it's owned by the cache!
}
