// This file is part of ESTmapper.
// Copyright (c) 2001, 2002, 2003, 2004 Applera Corporation
// Authors: Brian Walenz and Liliana Florea
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received (LICENSE.txt) a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#ifndef FASTA_SEQUENCEINCORE_H
#define FASTA_SEQUENCEINCORE_H

#include "fasta-types.H"

class FastASequenceInCore {
public:
  FastASequenceInCore(IID_t iid);
  FastASequenceInCore(IID_t iid, char *hdr, u32bit hdrlen, char *seq, u32bit seqlen);
  ~FastASequenceInCore();

  char           *header(void) const         { return(_header); };
  u32bit          headerLength(void) const   { return(_headerLen); };

  char           *sequence(void) const       { return(_seq); };
  u32bit          sequenceLength(void) const { return(_seqLen); };

  u32bit          getIID(void) const         { return(_idx); };
private:
  u32bit         _headerLen;
  u32bit         _headerMax;
  char          *_header;

  u32bit         _seqLen;
  u32bit         _seqMax;
  char          *_seq;

  u32bit         _idx;
};

#endif  //  FASTA_SEQUENCEINCORE_H
